/[gentoo-x86]/eclass/kde4-meta.eclass
Gentoo

Diff of /eclass/kde4-meta.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.16 Revision 1.29
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.16 2009/03/15 15:27:13 alexxy Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.29 2009/12/02 17:07:05 abcd Exp $
4# 4#
5# @ECLASS: kde4-meta.eclass 5# @ECLASS: kde4-meta.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: Eclass for writing "split" KDE packages. 8# @BLURB: Eclass for writing "split" KDE packages.
18 18
19if [[ -z ${KMNAME} ]]; then 19if [[ -z ${KMNAME} ]]; then
20 die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild" 20 die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
21fi 21fi
22 22
23case ${KDEBASE} in 23# Add khelpcenter dependency when installing handbooks
24 kde-base) 24if [[ ${PN} != khelpcenter ]] && has handbook ${IUSE//+}; then
25 HOMEPAGE="http://www.kde.org/" 25 RDEPEND+=" handbook? ( $(add_kdebase_dep khelpcenter) )"
26 LICENSE="GPL-2" 26fi
27 ;;
28 koffice)
29 HOMEPAGE="http://www.koffice.org/"
30 LICENSE="GPL-2"
31 ;;
32esac
33 27
34# Add dependencies that all packages in a certain module share. 28# Add dependencies that all packages in a certain module share.
35case ${KMNAME} in 29case ${KMNAME} in
36 kdebase|kdebase-apps|kdebase-workspace|kdebase-runtime|kdegraphic) 30 kdebase|kdebase-apps|kdebase-workspace|kdebase-runtime|kdegraphics)
37 DEPEND="${DEPEND}
38 >=kde-base/qimageblitz-0.0.4 31 COMMONDEPEND+=" >=kde-base/qimageblitz-0.0.4"
39 "
40 RDEPEND="${RDEPEND}
41 >=kde-base/qimageblitz-0.0.4
42 "
43 ;; 32 ;;
44 kdenetwork) 33 kdepim|kdepim-runtime)
45 DEPEND="${DEPEND} 34 COMMONDEPEND+=" $(add_kdebase_dep kdepimlibs)"
46 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
47 "
48 RDEPEND="${RDEPEND}
49 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
50 "
51 ;;
52 kdepim)
53 DEPEND="${DEPEND}
54 dev-libs/boost
55 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
56 "
57 RDEPEND="${RDEPEND}
58 dev-libs/boost
59 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
60 "
61 case ${PN} in 35 case ${PN} in
62 akregator|kaddressbook|kjots|kmail|kmobiletools|knode|knotes|korganizer|ktimetracker) 36 akregator|kaddressbook|kjots|kmail|knode|knotes|korganizer|ktimetracker)
63 IUSE="+kontact" 37 IUSE+=" +kontact"
64 RDEPEND="${RDEPEND} 38 if ! slot_is_at_least 4.4 ${SLOT} || [[ ${SLOT} == 4.4 && ${PV} < 4.3.68 ]]; then
65 kontact? ( >=kde-base/kontactinterfaces-${PV}:${SLOT}[kdeprefix=] ) 39 RDEPEND+=" kontact? ( $(add_kdebase_dep kontactinterfaces) )"
66 " 40 fi
67 ;; 41 ;;
68 esac 42 esac
69 ;; 43 ;;
70 kdegames) 44 kdegames)
71 if [[ ${PN} != libkdegames ]]; then 45 if [[ ${PN} != libkdegames ]]; then
72 DEPEND="${DEPEND} 46 COMMONDEPEND+=" $(add_kdebase_dep libkdegames)"
73 >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=]
74 "
75 RDEPEND="${RDEPEND}
76 >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=]
77 "
78 fi 47 fi
79 ;; 48 ;;
80 koffice) 49 koffice)
81 [[ ${PN} != koffice-data ]] && IUSE="debug" 50 [[ ${PN} != koffice-data ]] && IUSE+=" debug"
82 case ${PV} in 51 RDEPEND+="
83 9999*)
84 DEPEND="${DEPEND}
85 !app-office/${PN}:2
86 "
87 ;;
88 1.9*|2*)
89 DEPEND="${DEPEND}
90 !app-office/${PN}:live
91 "
92 ;;
93 esac
94 DEPEND="${DEPEND}
95 !app-office/${PN}:0 52 !app-office/${PN}:0
96 !app-office/koffice:0 53 !app-office/koffice:0
97 !app-office/koffice-meta:0 54 !app-office/koffice-meta:0
98 " 55 "
99 case ${PN} in 56 if has openexr ${IUSE//+}; then
100 koffice-data) 57 COMMONDEPEND+=" media-gfx/imagemagick[openexr?]"
101 DEPEND="${DEPEND} 58 else
102 media-libs/lcms 59 COMMONDEPEND+=" media-gfx/imagemagick"
103 " 60 fi
104 RDEPEND="${RDEPEND} 61
105 media-libs/lcms
106 "
107 ;;
108 *)
109 COMMON_DEPEND=" 62 COMMONDEPEND+="
110 dev-cpp/eigen:2 63 dev-cpp/eigen:2
111 media-gfx/imagemagick[openexr?]
112 media-libs/fontconfig 64 media-libs/fontconfig
113 media-libs/freetype:2 65 media-libs/freetype:2
114 " 66 "
115 DEPEND="${DEPEND} ${COMMON_DEPEND}"
116 RDEPEND="${RDEPEND} ${COMMON_DEPEND}"
117 unset COMMON_DEPEND
118 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then 67 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then
119 DEPEND="${DEPEND} 68 COMMONDEPEND+=" >=app-office/koffice-libs-${PV}:${SLOT}"
120 >=app-office/koffice-libs-${PV}:${SLOT}[kdeprefix=]
121 "
122 RDEPEND="${RDEPEND}
123 >=app-office/koffice-libs-${PV}:${SLOT}[kdeprefix=]
124 "
125 fi 69 fi
126 ;;
127 esac
128 ;; 70 ;;
129esac 71esac
72
73DEPEND+=" ${COMMONDEPEND}"
74RDEPEND+=" ${COMMONDEPEND}"
75unset COMMONDEPEND
130 76
131debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies" 77debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies"
132debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies" 78debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies"
133 79
134# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc) 80# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc)
135case ${BUILD_TYPE} in 81case ${BUILD_TYPE} in
136 live) 82 live)
137 case ${KMNAME} in 83 case ${KMNAME} in
138 extragear*|playground*) 84 extragear*|playground*)
139 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}" 85 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
86 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
140 ;; 87 ;;
141 esac 88 esac
142 ;; 89 ;;
143 *) ;;
144esac 90esac
145 91
146# @ECLASS-VARIABLE: KMNAME 92# @ECLASS-VARIABLE: KMNAME
147# @DESCRIPTION: 93# @DESCRIPTION:
148# Name of the parent-module (e.g. kdebase, kdepim, ...). You _must_ set it 94# Name of the parent-module (e.g. kdebase, kdepim, ...). You _must_ set it
170 116
171# @ECLASS-VARIABLE: KMEXTRA 117# @ECLASS-VARIABLE: KMEXTRA
172# @DESCRIPTION: 118# @DESCRIPTION:
173# All subdirectories listed here will be extracted, compiled & installed. 119# All subdirectories listed here will be extracted, compiled & installed.
174# $KMMODULE is always added to $KMEXTRA. 120# $KMMODULE is always added to $KMEXTRA.
175# If the htmlhandbook USE-flag is set, and if this directory exists, 121# If the handbook USE-flag is set, and if this directory exists,
176# then "doc/$KMMODULE" is added to $KMEXTRA. In other cases, this should be 122# then "doc/$KMMODULE" is added to $KMEXTRA. In other cases, this should be
177# handled in the ebuild. 123# handled in the ebuild.
178# If the documentation is in a different subdirectory, you should add it to KMEXTRA. 124# If the documentation is in a different subdirectory, you should add it to KMEXTRA.
179 125
180# @ECLASS-VARIABLE: KMCOMPILEONLY 126# @ECLASS-VARIABLE: KMCOMPILEONLY
265 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed" 211 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
266 fi 212 fi
267 else 213 else
268 local abort tarball tarfile f extractlist moduleprefix postfix 214 local abort tarball tarfile f extractlist moduleprefix postfix
269 case ${PV} in 215 case ${PV} in
270 4.2.9* | 4.2.8* | 4.2.7* | 4.2.6*) 216 4.3.8[05] | 4.3.9[0568])
271 KMTARPARAMS="${KMTARPARAMS} --lzma" # lzma 217 # block for normally packed upstream unstable snapshots
218 KMTARPARAMS+=" --bzip2" # bz2
219 postfix="bz2"
220 ;;
221 4.3.[6-9]*)
222 # Not passing --xz, as it doesn't work with stable tar
223 KMTARPARAMS+=" --use-compress-program=xz" # xz
272 postfix="lzma" 224 postfix="xz"
273 ;; 225 ;;
274 *) 226 *)
275 KMTARPARAMS="${KMTARPARAMS} --bzip2" # bz2 227 KMTARPARAMS+=" --bzip2" # bz2
276 postfix="bz2" 228 postfix="bz2"
277 ;; 229 ;;
278 esac 230 esac
279 case ${KMNAME} in 231 case ${KMNAME} in
280 kdebase-apps) 232 kdebase-apps)
281 # kdebase/apps -> kdebasa-apps 233 # kdebase/apps -> kdebase-apps
282 tarball="kdebase-${PV}.tar.${postfix}" 234 tarball="kdebase-${PV}.tar.${postfix}"
283 # Go one level deeper for kdebase-apps in tarballs 235 # Go one level deeper for kdebase-apps in tarballs
284 moduleprefix=apps/ 236 moduleprefix=apps/
285 KMTARPARAMS="${KMTARPARAMS} --transform=s|apps/||" 237 KMTARPARAMS+=" --transform=s|apps/||"
286 ;; 238 ;;
287 *) 239 *)
288 # Create tarball name from module name (this is the default) 240 # Create tarball name from module name (this is the default)
289 tarball="${KMNAME}-${PV}.tar.${postfix}" 241 tarball="${KMNAME}-${PV}.tar.${postfix}"
290 ;; 242 ;;
291 esac 243 esac
292 244
293 # Full patch to source tarball 245 # Full path to source tarball
294 tarfile="${DISTDIR}/${tarball}" 246 tarfile="${DISTDIR}/${tarball}"
295 247
296 # Detect real toplevel dir from tarball name - it will be used upon extraction 248 # Detect real toplevel dir from tarball name - it will be used upon extraction
297 # and in __list_needed_subdirectories 249 # and in __list_needed_subdirectories
298 topdir="${tarball%.tar.*}/" 250 topdir="${tarball%.tar.*}/"
302 kde4-meta_create_extractlists 254 kde4-meta_create_extractlists
303 255
304 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \ 256 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \
305 AUTHORS COPYING INSTALL README NEWS ChangeLog 257 AUTHORS COPYING INSTALL README NEWS ChangeLog
306 do 258 do
307 extractlist="${extractlist} ${topdir}${moduleprefix}${f}" 259 extractlist+=" ${topdir}${moduleprefix}${f}"
308 done 260 done
309 extractlist="${extractlist} $(__list_needed_subdirectories)" 261 extractlist+=" $(__list_needed_subdirectories)"
310 262
311 pushd "${WORKDIR}" > /dev/null 263 pushd "${WORKDIR}" > /dev/null
312 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} >&2 264 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} >&2
313 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null 265 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null
314 266
343# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, 295# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY,
344# KMEXTRACTONLY and KMTARPARAMS. 296# KMEXTRACTONLY and KMTARPARAMS.
345kde4-meta_create_extractlists() { 297kde4-meta_create_extractlists() {
346 debug-print-function ${FUNCNAME} "$@" 298 debug-print-function ${FUNCNAME} "$@"
347 299
300 # TODO change to KMEXTRA for more strict check
348 if has htmlhandbook ${IUSE//+} && use htmlhandbook; then 301 if has handbook ${IUSE//+} && use handbook && [[ -n ${KMMODULE} ]]; then
349 # We use the basename of $KMMODULE because $KMMODULE can contain 302 # We use the basename of $KMMODULE because $KMMODULE can contain
350 # the path to the module subdirectory. 303 # the path to the module subdirectory.
351 KMEXTRA_NONFATAL="${KMEXTRA_NONFATAL} doc/${KMMODULE##*/}" 304 KMEXTRA_NONFATAL+="
305 doc/${KMMODULE##*/}"
352 fi 306 fi
353 307
354 # Add some CMake-files to KMEXTRACTONLY. 308 # Add some CMake-files to KMEXTRACTONLY.
355 # Note that this actually doesn't include KMEXTRA handling. 309 # Note that this actually doesn't include KMEXTRA handling.
356 # In those cases you should care to add the relevant files to KMEXTRACTONLY 310 # In those cases you should care to add the relevant files to KMEXTRACTONLY
357 case ${KMNAME} in 311 case ${KMNAME} in
358 kdebase) 312 kdebase)
359 KMEXTRACTONLY="${KMEXTRACTONLY} 313 KMEXTRACTONLY+="
360 apps/config-apps.h.cmake 314 apps/config-apps.h.cmake
361 apps/ConfigureChecks.cmake" 315 apps/ConfigureChecks.cmake"
362 ;; 316 ;;
363 kdebase-apps) 317 kdebase-apps)
364 KMEXTRACTONLY="${KMEXTRACTONLY} 318 KMEXTRACTONLY+="
365 config-apps.h.cmake 319 config-apps.h.cmake
366 ConfigureChecks.cmake" 320 ConfigureChecks.cmake"
367 ;; 321 ;;
368 kdebase-runtime) 322 kdebase-runtime)
369 KMEXTRACTONLY="${KMEXTRACTONLY} 323 KMEXTRACTONLY+="
370 config-runtime.h.cmake" 324 config-runtime.h.cmake"
371 ;; 325 ;;
372 kdebase-workspace) 326 kdebase-workspace)
373 KMEXTRACTONLY="${KMEXTRACTONLY} 327 KMEXTRACTONLY+="
374 config-unix.h.cmake 328 config-unix.h.cmake
375 ConfigureChecks.cmake 329 ConfigureChecks.cmake
376 config-workspace.h.cmake 330 config-workspace.h.cmake
377 config-X11.h.cmake 331 config-X11.h.cmake
378 startkde.cmake 332 startkde.cmake
379 KDE4WorkspaceConfig.cmake.in" 333 KDE4WorkspaceConfig.cmake.in"
380 ;; 334 ;;
381 kdegames) 335 kdegames)
382 if [[ ${PN} != libkdegames ]]; then 336 if [[ ${PN} != libkdegames ]]; then
383 KMEXTRACTONLY="${KMEXTRACTONLY} 337 KMEXTRACTONLY+="
384 libkdegames" 338 libkdegames/"
385 fi 339 fi
386 ;; 340 ;;
387 kdepim) 341 kdepim)
388 if [[ ${PN} != libkdepim ]]; then 342 if [[ ${PN} != libkdepim ]]; then
389 KMEXTRACTONLY="${KMEXTRACTONLY} 343 KMEXTRACTONLY+="
390 libkdepim" 344 libkdepim/"
391 fi 345 fi
392 case ${SLOT} in 346 case ${SLOT} in
393 4.3|live) 347 4.3|4.4|live)
394 KMEXTRACTONLY="${KMEXTRACTONLY} 348 KMEXTRACTONLY+="
395 kdepim-version.h 349 kdepim-version.h
396 config-enterprise.h.cmake" 350 config-enterprise.h.cmake"
397 ;; 351 ;;
398 esac 352 esac
399 KMEXTRACTONLY="${KMEXTRACTONLY} 353 KMEXTRACTONLY+="
400 kleopatra/ConfigureChecks.cmake" 354 kleopatra/ConfigureChecks.cmake"
401 if has kontact ${IUSE//+} && use kontact; then 355 if has kontact ${IUSE//+} && use kontact; then
356 KMEXTRA+="
402 KMEXTRA="${KMEXTRA} kontact/plugins/${PLUGINNAME:-${PN}}" 357 kontact/plugins/${PLUGINNAME:-${PN}}/"
403 KMEXTRACTONLY="${KMEXTRACTONLY} kontactinterfaces/" 358 if ! slot_is_at_least 4.4 ${SLOT} || [[ ${SLOT} == 4.4 && ${PV} < 4.3.68 ]]; then
359 KMEXTRACTONLY+="
360 kontactinterfaces/"
361 fi
404 fi 362 fi
405 ;; 363 ;;
364 kdeutils)
365 case ${SLOT} in
366 4.3|4.4|live)
367 KMEXTRACTONLY+="
368 kdeutils-version.h"
369 ;;
370 esac
371 ;;
406 koffice) 372 koffice)
407 KMEXTRACTONLY="${KMEXTRACTONLY} 373 KMEXTRACTONLY+="
408 config-endian.h.cmake 374 config-endian.h.cmake
409 filters/config-filters.h.cmake 375 filters/config-filters.h.cmake
410 config-openctl.h.cmake
411 config-openexr.h.cmake 376 config-openexr.h.cmake
412 config-opengl.h.cmake 377 config-opengl.h.cmake
413 config-prefix.h.cmake" 378 config-prefix.h.cmake
379 "
380 case ${PV} in
381 2.0.*)
382 KMEXTRACTONLY+="
383 config-openctl.h.cmake"
384 ;;
385 esac
414 ;; 386 ;;
415 esac 387 esac
416 # Don't install cmake modules for split ebuilds, to avoid collisions. 388 # Don't install cmake modules for split ebuilds, to avoid collisions.
417 case ${KMNAME} in 389 case ${KMNAME} in
390 kdepim)
391 # No need for unpack since 4.2.86
392 # Remove when 4.2 is wiped out from the tree
393 case ${PV} in
394 4.2.[0-4])
395 KMCOMPILEONLY+="
396 cmake/modules/"
397 ;;
398 esac
399 ;;
418 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics|kdepim) 400 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics)
419 case ${PN} in 401 case ${PN} in
420 libkdegames|libkdeedu|marble|libkworkspace) 402 libkdegames|libkdeedu|libkworkspace)
421 KMEXTRA="${KMEXTRA} 403 KMEXTRA+="
422 cmake/modules/" 404 cmake/modules/"
423 ;; 405 ;;
424 *) 406 *)
425 KMCOMPILEONLY="${KMCOMPILEONLY} 407 KMCOMPILEONLY+="
426 cmake/modules/" 408 cmake/modules/"
427 ;; 409 ;;
428 esac 410 esac
429 ;; 411 ;;
430 esac 412 esac
435__list_needed_subdirectories() { 417__list_needed_subdirectories() {
436 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist 418 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist
437 419
438 # We expand KMEXTRA by adding CMakeLists.txt files 420 # We expand KMEXTRA by adding CMakeLists.txt files
439 kmextra="${KMEXTRA}" 421 kmextra="${KMEXTRA}"
440 [[ ${1} != fatal ]] && kmextra="${kmextra} ${KMEXTRA_NONFATAL}" 422 [[ ${1} != fatal ]] && kmextra+=" ${KMEXTRA_NONFATAL}"
441 for i in ${kmextra}; do 423 for i in ${kmextra}; do
442 kmextra_expanded="${kmextra_expanded} ${i}" 424 kmextra_expanded+=" ${i}"
443 j=$(dirname ${i}) 425 j=$(dirname ${i})
444 while [[ ${j} != "." ]]; do 426 while [[ ${j} != "." ]]; do
445 kmextra_expanded="${kmextra_expanded} ${j}/CMakeLists.txt"; 427 kmextra_expanded+=" ${j}/CMakeLists.txt";
446 j=$(dirname ${j}) 428 j=$(dirname ${j})
447 done 429 done
448 done 430 done
449 431
450 # Expand KMMODULE 432 # Expand KMMODULE
451 if [[ -n ${KMMODULE} ]]; then 433 if [[ -n ${KMMODULE} ]]; then
452 kmmodule_expanded="${KMMODULE}" 434 kmmodule_expanded="${KMMODULE}"
453 j=$(dirname ${KMMODULE}) 435 j=$(dirname ${KMMODULE})
454 while [[ ${j} != "." ]]; do 436 while [[ ${j} != "." ]]; do
455 kmmodule_expanded="${kmmodule_expanded} ${j}/CMakeLists.txt"; 437 kmmodule_expanded+=" ${j}/CMakeLists.txt";
456 j=$(dirname ${j}) 438 j=$(dirname ${j})
457 done 439 done
458 fi 440 fi
459 441
460 # Expand KMCOMPILEONLY 442 # Expand KMCOMPILEONLY
461 for i in ${KMCOMPILEONLY}; do 443 for i in ${KMCOMPILEONLY}; do
462 kmcompileonly_expanded="${kmcompileonly_expanded} ${i}" 444 kmcompileonly_expanded+=" ${i}"
463 j=$(dirname ${i}) 445 j=$(dirname ${i})
464 while [[ ${j} != "." ]]; do 446 while [[ ${j} != "." ]]; do
465 kmcompileonly_expanded="${kmcompileonly_expanded} ${j}/CMakeLists.txt"; 447 kmcompileonly_expanded+=" ${j}/CMakeLists.txt";
466 j=$(dirname ${j}) 448 j=$(dirname ${j})
467 done 449 done
468 done 450 done
469 451
470 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}" 452 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}"
474 # Create final list of stuff to extract 456 # Create final list of stuff to extract
475 # We append topdir only when specified (usually for tarballs) 457 # We append topdir only when specified (usually for tarballs)
476 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \ 458 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \
477 ${KMEXTRACTONLY} 459 ${KMEXTRACTONLY}
478 do 460 do
479 extractlist="${extractlist} ${topdir}${moduleprefix}${i}" 461 extractlist+=" ${topdir}${moduleprefix}${i}"
480 done 462 done
481 463
482 echo ${extractlist} 464 echo ${extractlist}
483} 465}
484 466
519 pushd "${S}" > /dev/null 501 pushd "${S}" > /dev/null
520 502
521 comment_all_add_subdirectory ./ 503 comment_all_add_subdirectory ./
522 504
523 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt 505 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt
524 if [[ -f "${S}"/CMakeLists.txt ]]; then 506 if [[ -f CMakeLists.txt ]]; then
525 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 507 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
526 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 508 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
527 -i "${S}"/CMakeLists.txt || die "${LINENO}: cmake sed died" 509 -i CMakeLists.txt || die "${LINENO}: cmake sed died"
528 fi 510 fi
529 511
530 if [[ -z ${KMNOMODULE} ]]; then 512 if [[ -z ${KMNOMODULE} ]]; then
531 # Restore "add_subdirectory" in $KMMODULE subdirectories 513 # Restore "add_subdirectory" in $KMMODULE subdirectories
532 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 514 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | \
515 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
533 die "${LINENO}: died in KMMODULE section" 516 die "${LINENO}: died in KMMODULE section"
534 _change_cmakelists_parent_dirs ${KMMODULE} 517 _change_cmakelists_parent_dirs ${KMMODULE}
535 fi 518 fi
536 519
537 local i 520 local i
538 521
539 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY 522 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
540 for i in ${KMEXTRACTONLY}; do 523 for i in ${KMEXTRACTONLY}; do
541 if [[ -d "${S}"/${i} && -f "${S}"/${i}/../CMakeLists.txt ]]; then 524 if [[ -d ${i} && -f ${i}/../CMakeLists.txt ]]; then
542 sed -i -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" "${S}"/${i}/../CMakeLists.txt || \ 525 sed -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" \
526 -i ${i}/../CMakeLists.txt || \
543 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}" 527 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
544 fi 528 fi
545 done 529 done
546 530
547 # KMCOMPILEONLY 531 # KMCOMPILEONLY
569 # KMEXTRA_NONFATAL section 553 # KMEXTRA_NONFATAL section
570 for i in ${KMEXTRA_NONFATAL}; do 554 for i in ${KMEXTRA_NONFATAL}; do
571 if [[ -d "${S}"/${i} ]]; then 555 if [[ -d "${S}"/${i} ]]; then
572 find "${S}"/${i} -name CMakeLists.txt -print0 | \ 556 find "${S}"/${i} -name CMakeLists.txt -print0 | \
573 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 557 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
574 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}" 558 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}"
575 _change_cmakelists_parent_dirs ${i} 559 _change_cmakelists_parent_dirs ${i}
576 fi 560 fi
577 done 561 done
578 562
579 case ${KMNAME} in 563 case ${KMNAME} in
580 kdebase-workspace) 564 kdebase-workspace)
581 # COLLISION PROTECT section 565 # COLLISION PROTECT section
582 # Install the startkde script just once, as a part of kde-base/kdebase-startkde, 566 # Install the startkde script just once, as a part of kde-base/kdebase-startkde,
583 # not as a part of every package. 567 # not as a part of every package.
584 if [[ ${PN} != kdebase-startkde && -f "${S}"/CMakeLists.txt ]]; then 568 if [[ ${PN} != kdebase-startkde && -f CMakeLists.txt ]]; then
585 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0. 569 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0.
586 sed -i -e '/startkde/s/^/#DONOTINSTALL /' "${S}"/CMakeLists.txt || \ 570 sed -e '/startkde/s/^/#DONOTINSTALL /' \
587 die "${LINENO}: sed died in the kdebase-startkde collision prevention section" 571 -i CMakeLists.txt || die "${LINENO}: sed died in the kdebase-startkde collision prevention section"
588 fi 572 fi
589 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82 573 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82
590 if [[ ${PN} != libkworkspace ]]; then 574 if [[ ${PN} != libkworkspace ]]; then
591 sed -i -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \ 575 sed -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \
592 CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip EXPORT section" 576 -i CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip config install and fix EXPORT section"
593 fi 577 fi
594 ;; 578 ;;
595 kdebase-runtime) 579 kdebase-runtime)
596 # COLLISION PROTECT section 580 # COLLISION PROTECT section
597 # Only install the kde4 script as part of kde-base/kdebase-data 581 # Only install the kde4 script as part of kde-base/kdebase-data
598 if [[ ${PN} != kdebase-data && -f "${S}"/CMakeLists.txt ]]; then 582 if [[ ${PN} != kdebase-data && -f CMakeLists.txt ]]; then
599 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \ 583 sed -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
600 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed" 584 -i CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
601 fi 585 fi
586 ;;
587 kdenetwork)
588 # Disable hardcoded kdepimlibs check
589 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
590 -i CMakeLists.txt || die "failed to disable hardcoded checks"
602 ;; 591 ;;
603 kdepim) 592 kdepim)
604 case ${PN} in 593 case ${PN} in
605 kaddressbook|kalarm|kmailcvt|kontact|korganizer|korn) 594 kaddressbook|kalarm|kmailcvt|kontact|korganizer|korn)
606 sed -i -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \ 595 sed -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \
607 -e '/add_custom_target(kmail_xml /,/)/p' "${S}"/kmail/CMakeLists.txt || die "uncommenting xml failed" 596 -e '/add_custom_target(kmail_xml /,/)/p' \
597 -i kmail/CMakeLists.txt || die "uncommenting xml failed"
608 _change_cmakelists_parent_dirs kmail 598 _change_cmakelists_parent_dirs kmail
609 ;; 599 ;;
610 esac 600 esac
601 ;;
602 kdewebdev)
603 # Disable hardcoded kdepimlibs check
604 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
605 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2)/' \
606 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt)/' \
607 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost)/' \
608 -i CMakeLists.txt || die "failed to disable hardcoded checks"
611 ;; 609 ;;
612 koffice) 610 koffice)
613 # prevent collisions 611 # prevent collisions
614 if [[ ${PN} != koffice-data ]]; then 612 if [[ ${PN} != koffice-data ]]; then
615 sed -i -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \ 613 sed -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \
616 "${S}"/cmake/modules/CMakeLists.txt || \ 614 -i cmake/modules/CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
615 sed -e '/install(.\+config-openexr\.h.\+)/d' \
617 die "${LINENO}: sed died in collision prevention section" 616 -i CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
618 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \
619 "${S}"/CMakeLists.txt || \
620 die "${LINENO}: sed died in collision prevention section"
621 fi 617 fi
618 # koffice 2.0
619 case ${PV} in
620 2.0.[1-9])
621 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \
622 "${S}"/CMakeLists.txt || \
623 die "${LINENO}: sed died in collision prevention section"
624 ;;
625 *) ;;
626 esac
622 esac 627 esac
623 628
624 popd > /dev/null 629 popd > /dev/null
625} 630}
626 631
629# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split 634# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split
630# ebuilds. 635# ebuilds.
631kde4-meta_src_configure() { 636kde4-meta_src_configure() {
632 debug-print-function ${FUNCNAME} "$@" 637 debug-print-function ${FUNCNAME} "$@"
633 638
639 # Set some cmake default values here (usually workarounds for automagic deps)
640 case ${KMNAME} in
641 kdewebdev)
642 mycmakeargs="
643 -DWITH_KdepimLibs=OFF
644 -DWITH_LibXml2=OFF
645 -DWITH_LibXslt=OFF
646 -DWITH_Boost=OFF
647 -DWITH_LibTidy=OFF
648 ${mycmakeargs}"
649 ;;
650 esac
651
634 kde4-base_src_configure 652 kde4-base_src_configure
635} 653}
636 654
637# @FUNCTION: kde4-meta_src_compile 655# @FUNCTION: kde4-meta_src_compile
638# @DESCRIPTION: 656# @DESCRIPTION:
639# General function for compiling split KDE4 applications. 657# General function for compiling split KDE4 applications.
640# Overrides kde4-base_src_compile. 658# Overrides kde4-base_src_compile.
641kde4-meta_src_compile() { 659kde4-meta_src_compile() {
642 debug-print-function ${FUNCNAME} "$@" 660 debug-print-function ${FUNCNAME} "$@"
643 661
644 kde4-base_src_compile 662 kde4-base_src_compile "$@"
645} 663}
646 664
647# @FUNCTION: kde4-meta_src_test 665# @FUNCTION: kde4-meta_src_test
648# @DESCRIPTION: 666# @DESCRIPTION:
649# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 667# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split
658# @DESCRIPTION: 676# @DESCRIPTION:
659# Function for installing KDE4 split applications. 677# Function for installing KDE4 split applications.
660kde4-meta_src_install() { 678kde4-meta_src_install() {
661 debug-print-function $FUNCNAME "$@" 679 debug-print-function $FUNCNAME "$@"
662 680
663 kde4-meta_src_make_doc 681 kde4-base_src_install
664 cmake-utils_src_install
665
666 if [[ -n ${KMSAVELIBS} ]]; then
667 install_library_dependencies
668 fi
669} 682}
670 683
671# @FUNCTION: kde4-meta_src_make_doc 684# @FUNCTION: kde4-meta_src_make_doc
672# @DESCRIPTION: 685# @DESCRIPTION:
673# This function searches in ${S}/${KMMODULE}, 686# This function searches in ${S}/${KMMODULE},
674# and tries to install "AUTHORS ChangeLog* README* NEWS todo" if these files exist. 687# and tries to install "AUTHORS ChangeLog* README* NEWS TODO" if these files exist.
675kde4-meta_src_make_doc() { 688kde4-meta_src_make_doc() {
676 debug-print-function ${FUNCNAME} "$@" 689 debug-print-function ${FUNCNAME} "$@"
677 690
678 local doc 691 local doc
679 for doc in AUTHORS ChangeLog* README* NEWS TODO; do 692 for doc in AUTHORS ChangeLog* README* NEWS TODO; do
683 kde4-base_src_make_doc 696 kde4-base_src_make_doc
684} 697}
685 698
686# @FUNCTION: kde4-meta_pkg_postinst 699# @FUNCTION: kde4-meta_pkg_postinst
687# @DESCRIPTION: 700# @DESCRIPTION:
688# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 701# Invoke kbuildsycoca4.
689# ebuilds.
690kde4-meta_pkg_postinst() { 702kde4-meta_pkg_postinst() {
691 debug-print-function ${FUNCNAME} "$@" 703 debug-print-function ${FUNCNAME} "$@"
692 704
693 kde4-base_pkg_postinst 705 kde4-base_pkg_postinst
694} 706}

Legend:
Removed from v.1.16  
changed lines
  Added in v.1.29

  ViewVC Help
Powered by ViewVC 1.1.20